<?php if(!defined('ABSPATH')) { die(); }  


add_action('plugins_loaded', function() {

	// Code Snippet Code

  add_filter( 'bricks/dynamic_tags_list', 'add_piecal_tags_to_builder' );
  add_filter( 'bricks/dynamic_data/render_tag', 'get_piecal_tag_value', 10, 3 );


  add_filter( 'bricks/dynamic_data/render_content', 'render_piecal_tag', 10, 3 );
  add_filter( 'bricks/frontend/render_data', 'render_piecal_tag', 10, 2 );
  

  /*
  * Here we define the our dynamic data tags.
  */
  function add_piecal_tags_to_builder( $tags ) {

    $tags[] = [
      'name'  => '{pc_is_event}',
      'label' => 'Pie Cal Event',
      'group' => 'Pie Cal Group',
    ];

    $tags[] = [
      'name'  => '{pc_is_allday}',
      'label' => 'Pie Cal All Day',
      'group' => 'Pie Cal Group',
    ];

    $tags[] = [
      'name'  => '{pc_start_date}',
      'label' => 'Pie Cal Start Date',
      'group' => 'Pie Cal Group',
    ];

    $tags[] = [
      'name'  => '{pc_end_date}',
      'label' => 'Pie Cal End Date',
      'group' => 'Pie Cal Group',
    ];

    $tags[] = [
      'name'  => '{pc_is_recurring}',
      'label' => 'Pie Cal Recurring Event',
      'group' => 'Pie Cal Group',
    ];

    $tags[] = [
      'name'  => '{pc_recurring_interval}',
      'label' => 'Pie Cal Recurring Interval',
      'group' => 'Pie Cal Group',
    ];

    $tags[] = [
      'name'  => '{pc_recurring_frequency}',
      'label' => 'Pie Cal Recurring Frequency',
      'group' => 'Pie Cal Group',
    ];

    $tags[] = [
      'name'  => '{pc_recurring_exact_position}',
      'label' => 'Pie Cal Recurring Position',
      'group' => 'Pie Cal Group',
    ];

    $tags[] = [
      'name'  => '{pc_recurring_end}',
      'label' => 'Pie Cal Recurring End',
      'group' => 'Pie Cal Group',
    ];
  /*  This is a beta option and is not yet implemented
    $tags[] = [
      'name'  => '{pc_rsets}',
      'label' => 'Pie Cal Recurring Beta',
      'group' => 'Pie Cal Group',
    ];
  */
    $tags[] = [
      'name'  => '{pc_color}',
      'label' => 'Pie Cal Color',
      'group' => 'Pie Cal Group',
    ];

    $tags[] = [
      'name'  => '{pc_text_color}',
      'label' => 'Pie Cal Text Color',
      'group' => 'Pie Cal Group',
    ];

    return $tags;
  }

  /*
  *  Render the tag into an array. Only 2 options allowed. The Meta Key and 
  *  optionally a date/time format. 
  */

  function get_piecal_tag_value( $tag, $post, $context = 'text' ) {
    // $tag is the tag name without the curly braces

    // Only look for dynamic tag starts with pc_tag:
    if ( strpos( $tag, 'pc_' ) === false ) {
      return $tag;
    }

    // Get argument in a array
    $argument = explode( ":", $tag, 2 );

    // Do your custom logic here, you should define run_my_dd_tag_logic() function
    $value = run_piecal_tag_logic( $argument );

    return $value;
  }

  /*
  *  This is where all the logic happens. First we need to get the post that we are on.
  *  Then the tag is checked that it is valid and what tag it is. Then the proper 
  *  routines are run to format the meta value into the proper format.
  */

  function run_piecal_tag_logic($argument) {

    $post_id = get_the_ID(); //Get the post ID so we know what post we are on


    /*
    *  This is where all the Pie Calendar meta fields are checked if they are valid
    *  and then the proper actions are performed on the meta field before it is returned.
    */
    switch( $argument[0] ) {
      case 'pc_is_event':
        $meta_value = esc_html( get_post_meta( $post_id,'_piecal_is_event', true ) );
        if ( $meta_value == '1' ) {
          $value = true;
        }
        else {
          $value = false;
        }
        break;

      case 'pc_is_allday':
        $meta_value = esc_html( get_post_meta( $post_id,'_piecal_is_allday', true ) );
        if ( $meta_value == '1' ) {
          $value = true;
        }
        else {
          $value = false;
        }
        break;

      case 'pc_start_date':
        $meta_value = esc_html( get_post_meta( $post_id,'_piecal_start_date', true ) );
        if ( empty( $meta_value ) ) {
          return $meta_value;
        }
        $value = piecal_format_date( $meta_value,$argument[1] );
        break;

      case 'pc_end_date':
        $meta_value = esc_html( get_post_meta( $post_id,'_piecal_end_date', true ) );
        if ( empty( $meta_value ) ) {
          return $meta_value;
        }
        $value = piecal_format_date( $meta_value,$argument[1] );
        break;

      case 'pc_is_recurring':
        $meta_value = esc_html( get_post_meta( $post_id,'_piecal_is_recurring', true ) );
        if ( $meta_value == '1' ) {
          $value = true;
        }
        else {
          $value = false;
        }
        break;

      case 'pc_recurring_interval':
        $meta_value = esc_html( get_post_meta( $post_id,'_piecal_recurring_interval', true ) );
        $value = (int)$meta_value;
        break;

      case 'pc_recurring_frequency':
        $meta_value = esc_html( get_post_meta( $post_id,'_piecal_recurring_frequency', true ) );
        $value = $meta_value;
        break;

      case 'pc_recurring_exact_position':
        $meta_value = esc_html( get_post_meta( $post_id,'_piecal_recurring_exact_position', true ) );
        if ( $meta_value == '1' ) {
          $value = true;
        }
        else {
          $value = false;
        }
        break;

      case 'pc_recurring_end':
        $meta_value = esc_html( get_post_meta( $post_id,'_piecal_recurring_end', true ) );
        if ( empty( $meta_value ) ) {
          return $meta_value;
        }
        $value = piecal_format_date( $meta_value,$argument[1] );
        break;

      /*  This is a beta option and is not yet implemented
      case 'pc_rsets':
        $meta_value = esc_html(get_post_meta($post_id,'_piecal_rsets', true) );
        break;
      */
      case 'pc_color':
        $meta_value = esc_html( get_post_meta( $post_id,'_piecal_color', true ) );
        $value = $meta_value;
        break;

      case 'pc_text_color':
        $meta_value = esc_html( get_post_meta( $post_id,'_piecal_text_color', true ) );
        $value = $meta_value;
        break;

      default: 
        $value = null;  // Not a valid tag, return nothing
      }

      return esc_html( $value );
  }
    

  function render_piecal_tag( $content, $post, $context = 'text' ) {

    // $content is the content of the element, including other dynamic tags, HTML, etc.

    // Only look for content starts with {pc_}
    if ( strpos( $content, '{pc_' ) === false ) {

      return $content;
    }
    
    // Regex to match pc_tag: tag
    preg_match_all( '/{(pc_[^}]+)}/', $content, $matches );

    // Nothing grouped in the regex, return the original content
    if ( empty( $matches[0] ) ) {
      return $content;
    }

    foreach ( $matches[1] as $key => $match ) {
      $tag = $matches[0][ $key ];

      // Get the dynamic data value, $match is the tag name without the curly brackets
      // Can reuse the get_my_tag_value function created earlier
      $value   = get_piecal_tag_value( $match, $post, $context );

      // Replace the tag with the transformed value
      $content = str_replace( $tag, $value, $content );
    }

    return $content;
  }


  /*
  *  This function formats the date in the desired format.
  */
  function piecal_format_date($date,$format) {
    if ( ( $format == null ) || ( $format == ':') ) {
      return $date;
    }

    if ( $format == 'c' ) {
      return $date . get_Wp_GMT_Offset();
    }
    // Add the current GMT offset to the end of the date string
    $date = strtotime( $date . get_Wp_GMT_Offset() );
    $time_zone = get_option( 'timezone_string' );
    $locale = get_locale();

   $fmt = datefmt_create(
      $locale,
      IntlDateFormatter::FULL,
      IntlDateFormatter::FULL,
      $time_zone,
      IntlDateFormatter::GREGORIAN,
    );

    datefmt_set_pattern( $fmt, $format );
  
    return datefmt_format( $fmt, $date );
  }


  function get_Wp_GMT_Offset() {  // Get the GMT offset of WordPress
    $offset  = get_option( 'gmt_offset' );
    $hours   = (int) $offset;
    $minutes = abs( ( $offset - (int) $offset ) * 60 );
    $offset  = sprintf( '%+03d:%02d', $hours, $minutes );
    return ( $offset );
  }

    // End Code Snippet Code

}, 10);